/*
 * light.c
 *
 *  Created on: Jul 8, 2021
 *      Author: OWNER
 */
#include "light.h"

volatile unsigned char lightSwitchState;
volatile unsigned char lightIntensityValue = 100;

void light_init(void) {
    GPIOB_ModeCfg( GPIO_Pin_14, GPIO_ModeOut_PP_5mA);    // PB14 - PWM10
    PWMX_CLKCfg(4);                   // cycle = 4/Fsys
    PWMX_CycleCfg(PWMX_Cycle_256);     //  = 256*cycle
    PWMX_ACTOUT( CH_PWM10, 0, Low_Level, ENABLE);     //
}

void lightIntensityControl(uint8_t value) {
    uint8_t lightValue;
    if (value > 100) {
        value = 100;
    } else if (value == 0) {
        value = 1;
    }
    lightSwitchState = 1;
    lightIntensityValue = value;
    lightValue = 255 / (101 - value);
    PWMX_ACTOUT( CH_PWM10, lightValue, Low_Level, ENABLE);     // ռձȵ
    PRINT("lightIntensityControl:%d\n",lightIntensityValue);
}


void lightSwitch(uint8 state)
{

    lightSwitchState = state;
    if(state){
        lightIntensityControl(lightIntensityValue);
    }else{
        PWMX_ACTOUT( CH_PWM10, 0, Low_Level, ENABLE);     // ռձȵ
        lightSwitchState = 0;
    }
    PRINT("lightSwitch:%d\n",lightSwitchState);
}
